local HU = hurryup
local HUC = hurryup.Console

//variables
HU.enabled = CV_RegisterVar{
  name = "hu_enable",
  defaultvalue = 1,
  flags = CV_NETVAR,
  PossibleValue = {Off = 0, On = 1}
}

HU.firsttrigger = CV_RegisterVar{
  name = "hu_firsttrigger",
  defaultvalue = 1,
  flags = CV_NETVAR,
  PossibleValue = {Off = 0, On = 1}
}

HU.pinchtime = CV_RegisterVar{
  name = "hu_pinchtime",
  defaultvalue = 30,
  flags = CV_NETVAR,
  PossibleValue = {MIN = 0, MAX = 999}
}

//instant commands
local hu = "[HurryUp] "

HUC.Help = COM_AddCommand("hurryup_help", function(player, ...)
	CONS_Printf(player, "\140"+hu+"Concept by \x81Mylo\140, scripted by \143Lumyni\140. Current version: \x80"+hurryup.version+" - "+hurryup.branch)
	CONS_Printf(player, "\140"+"Client Commands:\x80 hu_hurrytunes, hu_showhud")
	CONS_Printf(player, "\140"+"Server Commands:\x80 hu_enable, hu_force, hu_pinchtime, hu_firsttriger")
end)

HUC.Help2 = COM_AddCommand("hurryup", function(player, ...)
	COM_BufInsertText(player, "hurryup_help")
end)

HUC.ShowHud = COM_AddCommand("hu_showhud", function(p)
	if p and not p.hidehuhud
		CONS_Printf(p, "\140"+hu+"Speed Lines will on longer display during Hurry Up.")
		p.hidehuhud = true
	elseif p
		CONS_Printf(p, "\140"+hu+"Speed Lines will now display during Hurry Up.")
		p.hidehuhud = false
	end
end)

HUC.Force = COM_AddCommand("hu_force", function(player, time)
	if not(player and player.valid) then
		return print("Please wait until inside a game to use this command.")
	end
	if not player == server then
		return CONS_Printf(player, "Only the Server or Admin can use this.")
	end
	if exitcountdown then
		return CONS_Printf(player, "It's over. You can't change fate.")
	end
	local started = false
	for p in players.iterate do 
		if player.realtime then started = true end
	end
	if HU.IsIntermission or not started then
		return CONS_Printf(player, "Hold on! The race didn't even start yet.")
	end
	
	local time = tonumber(time)
	if not (time or norefresh) then
		CONS_Printf(player, "Usage: hu_force <seconds>")
	else
		HU.force = time
		HU.racecountup = 0
		K_SetRaceCountdown(time*TICRATE)
		print("Hurry Up! Forced by server.")
	end
end)

//secret commands
HUC.SpeedlinesPref = COM_AddCommand("ilikespeedlines", function(p)
	if p and not p.likesspeedlines
		CONS_Printf(p, "\140"+"Of course you do.")
		p.likesspeedlines = true
	elseif p
		CONS_Printf(p, "\140"+"Global Speed Lines dissabled... Lame.")
		p.likesspeedlines = false
	end
end)