local HU = hurryup
local HUH = HU.HUD

HUH.Vars = function()
	local delay = 3
	local initmovespeed = 12
	if not HU.racecountup or HU.racecountup == 1
		HUH.xmove = -264
		HUH.movespeed = initmovespeed
	end
	if HU.enabled.value and HUH.state and not paused
		HUH.xmove = $+HUH.movespeed
		if (leveltime % delay == 0)
			if HUH.state == "decel"
				HUH.movespeed = max(1,$-1)
			elseif HUH.state == "accel"
				HUH.movespeed = min(initmovespeed,$+1)
			end
		end
	end
end

HUH.Pinch = function(v, p)
	//for text
	local xoffset = 144
	local yoffset = 101
	local initflags = V_HUDTRANS|V_SNAPTOTOP|V_SNAPTOLEFT  // (V_YELLOWMAP) i really wish the color could be changed, but oh well
	local initflags2 = V_HUDTRANSHALF|V_SNAPTOTOP|V_SNAPTOLEFT
	local inittext = "HURRY UP!"
	//do not modify; changes dynamically
	local racecountup = HU.racecountup
	local text = inittext
	local flags = initflags
	local xmove = 0 //i just realised this reads 'schmoove'
	xmove = HUH.xmove
	
	if HU.enabled.value and p and p.valid and p.mo and p.mo.valid and (racecountup or p.likesspeedlines) and not p.hidehuhud then	
		//Pinch introduction text (ft. poorly made formula)
		if racecountup > 0 and racecountup < 35 //ease it to xoffset (center)
			HUH.state = "decel"
			
			xmove = min($, xoffset)
			
			if (racecountup % 3 == 0) and racecountup > 17
				flags = initflags2 //flash
			else
				flags = initflags
			end
			
		elseif racecountup >= 35 and racecountup <= 70 //ease it "offscreen"
			HUH.state = "accel"
			
			xmove = min($, 319-xoffset)
			flags = initflags2
		end
		
		//Completely hide text if it's supposed to be offscreen
		if (xoffset+xmove >= 319) or (racecountup > 70) then
			text = " "
		else
			text = text
		end
		
		//Finally, "Hurry up"!
		v.drawKartString(xoffset+xmove, yoffset, text, flags)
		
		//Speedlines, totally not taken from a GoldenShine mod or anything, I'd never do that, haha...
		if not paused
			local map = TC_RAINBOW
			local trans = V_90TRANS
			local color = SKINCOLOR_SILVER
			local xoffset = 75*FRACUNIT
			local yoffset = 50*FRACUNIT	
			xoffset = $-(p.speed-2*FRACUNIT)
			yoffset = $-(p.speed-2*FRACUNIT)
			
			if xoffset < 0
				xoffset = 0
			elseif xoffset > 75*FRACUNIT
				xoffset = 75*FRACUNIT
			end
			
			if yoffset < 0
				yoffset = 0
			elseif yoffset > 50*FRACUNIT
				yoffset = 50*FRACUNIT
			end
			
			//Get more intense the faster you are.
			if p.speed > 44*p.mo.scale
				trans = V_60TRANS
			elseif p.speed > 38*p.mo.scale
				trans = V_70TRANS
			elseif p.speed > 32*p.mo.scale
				trans = V_80TRANS
			end
			
			//Warmer colors the closer to explosion (I am evil I am insane)
			if racecountup
				if racecountdown < 1*TICRATE
					color = SKINCOLOR_KSUPER5
					trans = V_10TRANS
				elseif racecountdown < 2*TICRATE
					color = SKINCOLOR_KSUPER4
					trans = V_20TRANS
				elseif racecountdown < 3*TICRATE
					color = SKINCOLOR_KSUPER3
					trans = V_30TRANS
				elseif racecountdown < 4*TICRATE
					color = SKINCOLOR_KSUPER2
					trans = V_40TRANS
				elseif racecountdown < 5*TICRATE
					color = SKINCOLOR_KSUPER1
					trans = V_50TRANS
				elseif racecountdown < 6*TICRATE
					color = SKINCOLOR_TSUPER5
					trans = V_60TRANS
				elseif racecountdown < 7*TICRATE
					color = SKINCOLOR_TSUPER4
				elseif racecountdown < 8*TICRATE
					color = SKINCOLOR_TSUPER3
				elseif racecountdown < 9*TICRATE
					color = SKINCOLOR_TSUPER2
				elseif racecountdown < 10*TICRATE
					color = SKINCOLOR_TSUPER1
				elseif racecountdown < 11*TICRATE
					color = SKINCOLOR_SUPER5
				elseif racecountdown < 12*TICRATE
					color = SKINCOLOR_SUPER4
				elseif racecountdown < 13*TICRATE
					color = SKINCOLOR_SUPER3
				elseif racecountdown < 14*TICRATE
					color = SKINCOLOR_SUPER2
				elseif racecountdown < 15*TICRATE
					color = SKINCOLOR_SUPER1
				elseif racecountdown < 16*TICRATE
					color = SKINCOLOR_TSUPER1
				elseif racecountdown < 17*TICRATE
					color = SKINCOLOR_WSUPER2
				elseif racecountdown < 18*TICRATE
					color = SKINCOLOR_WSUPER3
				elseif racecountdown < 19*TICRATE
					color = SKINCOLOR_WSUPER4
				elseif racecountdown < 20*TICRATE
					color = SKINCOLOR_WSUPER5
				end
			end
			
			if not (leveltime % 2 == 0)
				v.drawScaled(0*FRACUNIT, 0-yoffset, FRACUNIT, v.cachePatch("YUZOTOP"), trans|V_SNAPTOTOP, v.getColormap(map, color))
				v.drawScaled(0*FRACUNIT, 96*FRACUNIT+yoffset, FRACUNIT, v.cachePatch("YUZOBOT"), trans|V_SNAPTOBOTTOM, v.getColormap(map, color))
				v.drawScaled(0-xoffset, 0, FRACUNIT, v.cachePatch("YUZOLEFT"), trans|V_SNAPTOLEFT, v.getColormap(map, color))		
				v.drawScaled(210*FRACUNIT+xoffset, 0, FRACUNIT, v.cachePatch("YUZORIGT"), trans|V_SNAPTORIGHT, v.getColormap(map, color))	
			else
				v.drawScaled(320*FRACUNIT, 0-yoffset, FRACUNIT, v.cachePatch("YUZOTOP"), trans|V_SNAPTOTOP|V_FLIP, v.getColormap(map, color))
				v.drawScaled(320*FRACUNIT, 96*FRACUNIT+yoffset, FRACUNIT, v.cachePatch("YUZOBOT"), trans|V_SNAPTOBOTTOM|V_FLIP, v.getColormap(map, color))
				v.drawScaled(320*FRACUNIT+xoffset, 0, FRACUNIT, v.cachePatch("YUZOLEFT"), trans|V_SNAPTORIGHT|V_FLIP, v.getColormap(map, color))		
				v.drawScaled(110*FRACUNIT-xoffset, 0, FRACUNIT, v.cachePatch("YUZORIGT"), trans|V_SNAPTOLEFT|V_SNAPTOTOP|V_FLIP, v.getColormap(map, color))
			end
		end
	end
end